#include <iostream>
#include <fstream>
#include "StructKaoSwap.h"

using namespace std;


char szKaoswapFileName[] = "KAOSWAP.N6P";
char szKaoswapUxFileName[] = "KAOSWAPUX.N6P";
char szKaoswapUxSilhouette[] = "KaoswapUXMaker.dat2";

KAOSWAP_TENSHOUKI<1332>	srcKaoSwap;		// KAOSWAP  \z邽߂̃oCi
KAOSWAP_TENSHOUKI<2932>	dstKaoSwapUX;	// KAOSWAPUX\z邽߂̃oCi

// KaoSwapUxp̃VGbg
struct KAOSWAP_TENSHOUKI_SILHOUETTE
{
	KAOSWAP_TENSHOUKI_FACE_64x80 face[1600];
} srcKaoSwapSilhouette;

enum ErrorType { NoErr = 0, ErrNoTargetFile = -1, ErrNoKaoSwap = -6, ErrDefaultKaoswap = -8, ErrBrokenKaoswap = -9 };

/*
* Xbvt@CǂsrcKaoSwapɊi[B
*/
ErrorType ReadKaoSwap() {
	fstream inKaoSwap;

	// ꂪƁAȂt@CFȂƂc
	DWORD dwAttr = ::GetFileAttributes(szKaoswapFileName);

	if (dwAttr == 0xffffffff) {
		cout << endl << "NoExist:" << szKaoswapFileName << endl;
	}

	if (!inKaoSwap) { return ErrNoKaoSwap; }


	inKaoSwap.open(szKaoswapFileName, ios::in | ios::binary);

	// Xbv\̂ւƃRs[
	inKaoSwap.read((char *)(&srcKaoSwap), sizeof(srcKaoSwap));

	// t@CTCY𒲂ׂ
	size_t fileSize = (size_t)inKaoSwap.seekg(0, ios::end).tellg();

	cout << (int)fileSize << endl;

	// CDftHB
	if (fileSize == 339854) {
		return ErrDefaultKaoswap;
	}

	// Xg[̃|C^ԑO sv܂ÂŁc
	inKaoSwap.seekg(0, ios::beg);

	return NoErr;
}

/*
* XbvpVGbgt@CǂsrcKaoSwapSilhouetteɊi[B
*/
ErrorType ReadKaoSwapSilhouette() {
	fstream inKaoSwap;

	// ꂪƁAȂt@CFȂƂc
	DWORD dwAttr = ::GetFileAttributes(szKaoswapUxSilhouette);
	if (dwAttr == 0xffffffff) {
		cout << endl << "NoExist:" << szKaoswapUxSilhouette << endl;
	}

	inKaoSwap.open(szKaoswapUxSilhouette, ios::in | ios::binary);

	if (!inKaoSwap) { return ErrNoTargetFile; }

	// Xbv\̂ւƃRs[
	inKaoSwap.read((char *)(&srcKaoSwapSilhouette), sizeof(srcKaoSwapSilhouette));
	return NoErr;

}

/*
* fop\̂łdstKaoSwapUX
*/
void InitKaoswapUx() {
	// UX̃tO͑SĂPɎdĂȂ
	memset(dstKaoSwapUX.flag, 0x01, sizeof(dstKaoSwapUX.flag));

	// UX̊e͑S0xFFԂɂBSĂ̊͐^
	memset(dstKaoSwapUX.face, 0xFF, sizeof(dstKaoSwapUX.face));
}

/*
* srcKaoWwap\́dstKaoSwapUXւƃRs[BtOAƂ擪̐lRs[
*/
void CopyKaoswapToKaoswapUx() {
	memcpy((char *)(&dstKaoSwapUX.flag), (char *)(&srcKaoSwap.flag), sizeof(srcKaoSwap.flag));
	memcpy((char *)(&dstKaoSwapUX.face), (char *)(&srcKaoSwap.face), sizeof(srcKaoSwap.face));
}

/*
* dstKaoSwapUX̎c̕srcKaoSwapSilhouetteRs[
*/
void CopyKaoswapSilhouetteToKaoswapUx() {
	// 0IWŁA1332Ԉȍ~
	memcpy((char *)(&dstKaoSwapUX.face[1332]), (char *)(&srcKaoSwapSilhouette.face), sizeof(srcKaoSwapSilhouette.face));
}

/*
* XbvpKaoswapUX.n6pt@CdstKaoSwapUX\̂珑o
*/
ErrorType WriteKaoSwap() {
	fstream outKaoSwap;

	outKaoSwap.open(szKaoswapUxFileName, ios::out | ios::binary);

	if (!outKaoSwap) { return ErrNoKaoSwap; }

	// XbvւƏ
	outKaoSwap.write((char *)(&dstKaoSwapUX), sizeof(dstKaoSwapUX));
	return NoErr;

}

void main(void) {

	ErrorType iErr = ReadKaoSwap();
	if (iErr == ErrDefaultKaoswap) {
		cout << "̃t@CCDYt̂̂ƓłB1332lpƂĂ1932lpƂĂp\łB̕Kv͂܂B" << endl;
		cout << "\nĂc\n";
		getchar();
		exit(-1);
	}
	if (iErr == ErrBrokenKaoswap) {
		cout << "KAOSWAP.N6P͂łɃc[ŔFs\ȏԂƂȂĂ܂Ă܂Bo܂B" << endl;
		cout << "\nĂc\n";
		getchar();
		exit(-1);
	}

	cout << "KAOSWAP.N6P̊̉摜𓊉eāAKAOSWAPUX.N6P쐬܂B\n";
	cout << "KAOSWAPUX.N6P ݂ƂĂAe͂Ȃ㏑܂!!BobNAbvƂƂȂ獡!!\n";
	cout << "蔲c[ł߂˥orz\n";
	cout << "\nĂc\n";
	getchar();

	// -------------ʏ폈X^[g---------------
	ReadKaoSwapSilhouette();

	InitKaoswapUx();

	CopyKaoswapToKaoswapUx();
	CopyKaoswapSilhouetteToKaoswapUx();

	WriteKaoSwap();
}

