#pragma once

#pragma pack(1)

#include <windows.h>
#include <iostream>
#include <fstream>

#include "StructBitMap.h"
#include "StructKaoSwap.h"

using namespace std;


extern int Cnv8BmpPixelTo8TSPixel(int []);


template <int BUSHOU_NUM>	// 1332=ʏ펞̐̕B1932lȂǗpɕύXł悤ev[g
class BitMapToKaoSwapManager {

  public:
	enum ErrorType { NoErr=0,  ErrNoTargetFile=-1, ErrWrongWHPixel=-2, ErrOutOfRange=-3, ErrColorPalette=-5, ErrNoKaoSwap=-6, ErrDefaultKaoswap=-8 };

	//				CDftHB1NB@ʏKaoSwap.n6pTCY
	enum FileSile { DefaultKaoSwapSize=339854, NormalKaoSwapSize=2558772 };
	

  private:
	char szBMPFaceFileName[32];		// 0000.bmp 0000͔ԍ 0001X^[g
	char szBMPFaceFileFormat[32];   // ".\\kao_3bit\\%04d.bmp"

	
	struct BITMAPHEADER {			// rbg}bvƂ肾p̃wb_\́B
		BITMAPFILEHEADER bfh;
		BITMAPINFOHEADER bih;
	};

	// BMPǂݍލۂ̈ꎞobt@B
	// ۂɂ́A炭́A2678oCgɂȂP[XłB
	// ꉞAKic[ɂđ㉺
	// (AƂƂɁA摜ełwb_o[Wăt@CTCY邱Ƃ͂Ȃ̂ŁAőSvB)
	// A牽łÃTCY傫͕̂ςȂ̂ŃG[
	char bufBMPFaceFile[3000];


	BITMAP_TENSHOUKI_FACE orgBmpFace;	// Jg^[Qbg̕BMPt@CoCi


  private:
	BYTE isFileExistOfTargetBushou[BUSHOU_NUM];		// ^[QbgƂȂ镐BMP݂͑H

	KAOSWAP_TENSHOUKI<BUSHOU_NUM>	dstKaoSwap;		// KAOSWAP  \z邽߂̃oCi
	char szKaoswapFileName[32];						// KAOSWAP̃t@Cl[


  public:
	BitMapToKaoSwapManager(char* szKaoSwapName) {

		// t@Ĉ̂̃Xg
		memset( isFileExistOfTargetBushou, 0, BUSHOU_NUM );

		// ͑S0xFFԂɂBSĂ̊͐^
		memset( dstKaoSwap.face, 0xFF, sizeof(dstKaoSwap.face) );

		// tO͑SĂPɎdĂȂ
		memset( dstKaoSwap.flag, 0x01, BUSHOU_NUM );

		// rbg}bvtH[}bg̖p^[Bŕږߍ݂ĂǂȂ́c
		strcpy_s(szBMPFaceFileFormat, ".\\kao_3bit\\%04d.bmp");

		// kaoswap.n6pƂkaoswapex.n6pƂΏۂ̖OۑĂ
		strcpy_s(szKaoswapFileName, szKaoSwapName);
	}

	// Ŝ̏s
	ErrorType Execute(int iFileNo) {

		ErrorType iErrorID;

		// t@CJāAobt@ւƊi[
		iErrorID = OpenBmpFile( iFileNo );

		// G[΁c
		if ( !iErrorID ) {
			// obt@ɓǂݍ񂾃C[WBMP\̂ւƊi[B
			iErrorID = ToCopyBmpStruct();
			if ( iErrorID == ErrWrongWHPixel ) {
				cout << endl << szBMPFaceFileName << ":" << "ErrWrongWidthHeightPixel" << endl;
				getchar();
			}
		}

		// G[΁c
		// ̒G[^Cvcctbc
		if ( !iErrorID ) {
			try {
				// ϊ
				CnvBmpToKaoswap( iFileNo );
			} catch (char *szErrMsg) {
				cout << endl << szBMPFaceFileName << ":" << szErrMsg << endl;
				getchar();
			}
		}

		return iErrorID;
	}

	// Xbvt@CǂŃoɊi[B
	ErrorType ReadKaoSwap() {
		cout << endl << endl << szKaoswapFileName << ":" << endl;

		fstream inKaoSwap;

		// ꂪƁAȂt@CFȂƂc
		DWORD dwAttr = ::GetFileAttributes(szKaoswapFileName);
		if(dwAttr == 0xffffffff) {
			cout << endl << "NoExist:" << szKaoswapFileName << endl;
			return ErrNoKaoSwap;
		}


		inKaoSwap.open(szKaoswapFileName, ios::in|ios::binary);

		if (!inKaoSwap) { 
			return ErrNoKaoSwap;
		}

		// Xbv\̂ւƃRs[
		inKaoSwap.read( (char *)(&dstKaoSwap), sizeof(dstKaoSwap) );

		// t@CTCY𒲂ׂ
		size_t fileSize = (size_t)inKaoSwap.seekg(0, ios::end).tellg();

		// t@CTCYACDftH̃TCYȂG[lԂĂB
		if ( fileSize == DefaultKaoSwapSize ) {
			cout << ":" << "ErrUnUsedKaoSwapSize" << endl;
			getchar();
			return ErrDefaultKaoswap;
		}
		
		return NoErr;

	}

	// Xbvt@Co܂܏oB
	ErrorType WriteKaoSwap() {
		

		fstream outKaoSwap;

		// ꂪƁAȂt@CFȂƂc
		DWORD dwAttr = ::GetFileAttributes(szKaoswapFileName);

		if(dwAttr == 0xffffffff) {
			cout << endl<< szKaoswapFileName << ":NoExist" << endl;
			return ErrNoKaoSwap;
		}

		outKaoSwap.open(szKaoswapFileName, ios::out|ios::binary);

		if (!outKaoSwap) { return ErrNoKaoSwap; }

		// XbvւƏ
		outKaoSwap.write( (char *)(&dstKaoSwap), sizeof(dstKaoSwap) );
		return NoErr;

	}


	// w̕BMPt@CPJ`obt@֊i[܂
	ErrorType OpenBmpFile(int iFileNo) {

		if ( iFileNo <= 0 || BUSHOU_NUM < iFileNo ) { return ErrOutOfRange; }

		// ԍt@Cւ̕ϊ
		wsprintf(szBMPFaceFileName, szBMPFaceFileFormat, iFileNo);

		// ꂪƁAȂt@CFȂƂc
		DWORD dwAttr = ::GetFileAttributes(szBMPFaceFileName);

		if(dwAttr != 0xffffffff) {
			cout << ".";
		}

		fstream fin;
		fin.open(szBMPFaceFileName, ios::in|ios::binary);

		// t@C݂Ȃ΁c
		if (!fin) {
			// Y̕ԍ̃t@C͖B0IWzȂ̂-1邱ƁB
			isFileExistOfTargetBushou[iFileNo-1] = 0;
			return ErrNoTargetFile; // ̃t@C݂͑ȂB
		}

		// obt@ւƓǂݍ
		fin.read( bufBMPFaceFile, sizeof(bufBMPFaceFile) );

		// obt@ɃRŝł
		fin.close();

		return NoErr;
	}

	// rbg}bv\̂ւ̊i[܂
	ErrorType ToCopyBmpStruct() {

		// rbg}bvwb_[̃CX^X
		BITMAPHEADER *BitMapHeader;

		// obt@̐擪BMPwb_[|C^ƂĈB
		BitMapHeader = (BITMAPHEADER *)bufBMPFaceFile;

		// 64, c80`FbN
		if ( BitMapHeader->bih.biWidth!=64 || BitMapHeader->bih.biHeight!=80 ) {
			return ErrWrongWHPixel; // ̃t@C͉fTCYقȂ		
		}

		// 摜en܂Ăꏊ肵A摜eBMP\̗p̊i[ꏊɃRs[
		int bfOffBits = BitMapHeader->bfh.bfOffBits;
		memcpy( &orgBmpFace, (bufBMPFaceFile+bfOffBits), sizeof(orgBmpFace) );

		return NoErr;

	}

	ErrorType CnvBmpToKaoswap(int iFileNo) {
		// SWAP̊痘ptOONɂB
		dstKaoSwap.flag[iFileNo-1] = 0x01; // ܂͋̕ƂƂƂȂB

		// i[wĂBϊxɂRoCgi߂Ȃ΂ȂȂB
		// z0IWȂ̂Ţ-1
		char *pface = (char *)&(dstKaoSwap.face[iFileNo-1]);

		// 摜̌̂aloł́A摜éAԍŌ̃Cŏ̃CւƌĕłB
		// AVċLł́A摜̈ԍŏŌɌāAłB
		// āAalo̍Ōォŏ֌ČvZAVċLpւƊi[Ă䂭B
		for ( int iLineIX = FACE_LINE_NUM-1; iLineIX>=0; iLineIX--) {

			// epbNƕϊB64sNZ88B
			for (int iPackIX=0; iPackIX<(64/8); iPackIX++) {

				// ƒ̂ŎQƂŁc
				BIT8PIXEL_PACK &bit8pack = orgBmpFace.bit64pixel_line[iLineIX].bit8pixel_pack[iPackIX];

				// YBMP̂W̃sNZoCiVċL^Cv̂SoCg(ʂPoCg00)ւƕϊĕԂ
				int arrPixel[] = {
					bit8pack.pixel1,
					bit8pack.pixel2,
					bit8pack.pixel3,
					bit8pack.pixel4,
					bit8pack.pixel5,
					bit8pack.pixel6,
					bit8pack.pixel7,
					bit8pack.pixel8,
				};
				// ϊ
				try {
					int iPackCnvResult = Cnv8BmpPixelTo8TSPixel(arrPixel);

					// ܂܂邻̓eRs[̂ł͂ȂA3oCgRs[
					memcpy(pface, &iPackCnvResult, 3);

					// RoCgi܂
					pface += 3;

				} catch (char *szErrMsg) {
					throw szErrMsg;
				}
			}
		}

		return NoErr;
	}

};
